library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_arith.ALL;
use IEEE.std_logic_unsigned.ALL;

entity tb_Spi_Master is
end tb_Spi_Master;

architecture RTL of tb_Spi_Master is

component Spi_Master
    Port ( 	CLK  	: in   std_logic;
			RESET 	: in   std_logic;
			Datain	: in   std_logic_vector( 15 downto 0);
			SCLK 	: out  std_logic;
			MOSI 	: out  std_logic;
			MISO 	: in   std_logic;
			CS1		: out  std_logic);  	-- Slave Chip Select#1 
end component;

signal  CLK  	:  std_logic:= '0';
signal	RESET 	:  std_logic;
signal	Datain	:  std_logic_vector( 15 downto 0);
signal	SCLK 	:  std_logic := '0';
signal	MOSI 	:  std_logic;
signal	MISO 	:  std_logic;
signal	CS1		:  std_logic;  				 
----------------------------------------------------------------
-- signal data_serial 	: std_logic;
constant T	: time:= 10 ns;

begin
-- *******************    Port Map   ****************************
DUT : Spi_Master port map (
							CLK  	=> CLK,  	
							RESET	=> RESET ,	
                            Datain	=> Datain,	
                            SCLK	=> SCLK,
                            MOSI	=> MOSI, 	
							MISO	=> MISO, 	
                            CS1		=> CS1	
							);	
							
-- *********** clk and reset definition ************************

 clk <= not clk after T; -- 50 MHz

	process 
	begin
	reset <= '0'; wait for T + 10 ns;
	reset <= '1'; wait for T + 10 ns;
	end process;


-- *********** Generating data **********************************
Datain <= "1010101010101010"; -- 16 Bit
process
begin
	for i in 15 downto 0 loop
		wait until SCLK = '1' and SCLK'event;
		MISO <= Datain(i);
	end loop;
end process;

				
end RTL;